require 'types'

module NcRna
	
	def find_nc_rna(seq, blast_query)
		
		# used to detect if the sequence and the blast are from different query
		if seq.seq_name != blast_query.query_def
			raise "BLAST query name and sequence are different"
		end
		
		hit=blast_query.hits.first
		
		if !hit.nil? && hit.align_len >= 40 # There is match in blast and it has a good length.
			seq.hit = hit
			seq.type = NCRNA
		end
	end
end
